
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
        <link rel="canonical" href="https://autovtools.gitlab.io/autovrtfm/usage/rdn/tun/">
      
      
        <link rel="prev" href="../listen/">
      
      
        <link rel="next" href="../dns/">
      
      
      <link rel="icon" href="../../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.5.3, mkdocs-material-9.4.6">
    
    
      
        <title>Tun - autovnet</title>
      
    
    
      <link rel="stylesheet" href="../../../assets/stylesheets/main.35e1ed30.min.css">
      
        
        <link rel="stylesheet" href="../../../assets/stylesheets/palette.356b1318.min.css">
      
      


    
    
      
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="../../../stylesheets/extra.css">
    
    <script>__md_scope=new URL("../../..",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
  </head>
  
  
    
    
      
    
    
    
    
    <body dir="ltr" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo">
  
    
    
      <script>var palette=__md_get("__palette");if(palette&&"object"==typeof palette.color)for(var key of Object.keys(palette.color))document.body.setAttribute("data-md-color-"+key,palette.color[key])</script>
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#tun" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

  

<header class="md-header md-header--shadow md-header--lifted" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-header__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            autovnet
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              Tun
            
          </span>
        </div>
      </div>
    </div>
    
      
        <form class="md-header__option" data-md-component="palette">
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to light mode"  type="radio" name="__palette" id="__palette_1">
    
      <label class="md-header__button md-icon" title="Switch to light mode" for="__palette_2" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 7H7a5 5 0 0 0-5 5 5 5 0 0 0 5 5h10a5 5 0 0 0 5-5 5 5 0 0 0-5-5m0 8a3 3 0 0 1-3-3 3 3 0 0 1 3-3 3 3 0 0 1 3 3 3 3 0 0 1-3 3Z"/></svg>
      </label>
    
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="default" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to dark mode"  type="radio" name="__palette" id="__palette_2">
    
      <label class="md-header__button md-icon" title="Switch to dark mode" for="__palette_1" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 6H7c-3.31 0-6 2.69-6 6s2.69 6 6 6h10c3.31 0 6-2.69 6-6s-2.69-6-6-6zm0 10H7c-2.21 0-4-1.79-4-4s1.79-4 4-4h10c2.21 0 4 1.79 4 4s-1.79 4-4 4zM7 9c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"/></svg>
      </label>
    
  
</form>
      
    
    
    
      <label class="md-header__button md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
        <div class="md-search__suggest" data-md-component="search-suggest"></div>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list" role="presentation"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
      </div>
    
  </nav>
  
    
      
<nav class="md-tabs" aria-label="Tabs" data-md-component="tabs">
  <div class="md-grid">
    <ul class="md-tabs__list">
      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../.." class="md-tabs__link">
          
  
  Home

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../rtfm/" class="md-tabs__link">
          
  
  RTFM

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../demo/" class="md-tabs__link">
          
  
  Demo

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../setup/" class="md-tabs__link">
          
  
  Setup

        </a>
      </li>
    
  

      
        
  
  
    
  
  
    
    
      <li class="md-tabs__item md-tabs__item--active">
        <a href="../../" class="md-tabs__link">
          
  
  Usage

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../help/" class="md-tabs__link">
          
  
  Reference

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../resources/faq/" class="md-tabs__link">
          
  
  Resources

        </a>
      </li>
    
  

      
    </ul>
  </div>
</nav>
    
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


  


  

<nav class="md-nav md-nav--primary md-nav--lifted md-nav--integrated" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-nav__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    autovnet
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_1" >
        
          
          <label class="md-nav__link" for="__nav_1" id="__nav_1_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Home
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_1_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_1">
            <span class="md-nav__icon md-icon"></span>
            Home
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../.." class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_2" >
        
          
          <label class="md-nav__link" for="__nav_2" id="__nav_2_label" tabindex="">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_2">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/paradigm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Paradigm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/autovnet/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/goals/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Goals
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_3" >
        
          
          <label class="md-nav__link" for="__nav_3" id="__nav_3_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Demo
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_3">
            <span class="md-nav__icon md-icon"></span>
            Demo
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Demo
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/callback/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Callback
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_4" >
        
          
          <label class="md-nav__link" for="__nav_4" id="__nav_4_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Setup
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_4">
            <span class="md-nav__icon md-icon"></span>
            Setup
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Quick Start
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/network/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Network Design
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/install/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Install
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/configure/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Configure
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/local/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Local Install
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
    
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--active md-nav__item--section md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_5" checked>
        
          
          <label class="md-nav__link" for="__nav_5" id="__nav_5_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Usage
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_5_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_5">
            <span class="md-nav__icon md-icon"></span>
            Usage
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Usage
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
    
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_5_2" checked>
        
          
          <label class="md-nav__link" for="__nav_5_2" id="__nav_5_2_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RDN
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_2_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_5_2">
            <span class="md-nav__icon md-icon"></span>
            RDN
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RDN
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../listen/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Listen
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          
  
  <span class="md-ellipsis">
    Tun
  </span>
  

          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        
  
  <span class="md-ellipsis">
    Tun
  </span>
  

      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#intro" class="md-nav__link">
    Intro
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#how-it-works" class="md-nav__link">
    How it Works
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#listen-tun" class="md-nav__link">
    Listen Tun
  </a>
  
    <nav class="md-nav" aria-label="Listen Tun">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#example" class="md-nav__link">
    Example
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#redirect-example" class="md-nav__link">
    Redirect Example
  </a>
  
    <nav class="md-nav" aria-label="Redirect Example">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#binding-to-udp-53" class="md-nav__link">
    Binding to UDP 53
  </a>
  
    <nav class="md-nav" aria-label="Binding to UDP 53">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#create-the-tun" class="md-nav__link">
    Create the Tun
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#start-merlin" class="md-nav__link">
    Start Merlin
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#start-listener" class="md-nav__link">
    Start Listener
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#create-the-redirect" class="md-nav__link">
    Create the Redirect
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#deploy-payload" class="md-nav__link">
    Deploy Payload
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#connect-tun" class="md-nav__link">
    Connect Tun
  </a>
  
    <nav class="md-nav" aria-label="Connect Tun">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#example_1" class="md-nav__link">
    Example
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#auto-roll" class="md-nav__link">
    Auto-Roll
  </a>
  
    <nav class="md-nav" aria-label="Auto-Roll">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#example_2" class="md-nav__link">
    Example
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../dns/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    DNS
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_3" >
        
          
          <label class="md-nav__link" for="__nav_5_3" id="__nav_5_3_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_3">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/apt/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    APT
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/pasta/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Pasta
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_4" >
        
          
          <label class="md-nav__link" for="__nav_5_4" id="__nav_5_4_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Pwn
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_4">
            <span class="md-nav__icon md-icon"></span>
            Pwn
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwn
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/share/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    File Hosting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/pwncat/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwncat
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/winrm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    evil-winrm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/metasploit/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    metasploit
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/merlin/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    merlin
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/sliver/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    sliver
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/ligolo_ng/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    ligolo-ng
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_5" >
        
          
          <label class="md-nav__link" for="__nav_5_5" id="__nav_5_5_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_5_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_5">
            <span class="md-nav__icon md-icon"></span>
            Collaboration
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/svc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Services
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/fs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Directories
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/vnc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Screen Sharing
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/hedgedoc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Notes
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/msfdb/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    msfdb
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/gitea/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    gitea
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/focalboard/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    focalboard
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/drawio/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    drawio
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/cyberchef/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    cyberchef
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/matrix/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    matrix
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/nextcloud/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    nextcloud
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/owncast/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    owncast
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_6" >
        
          
          <label class="md-nav__link" for="__nav_5_6" id="__nav_5_6_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Util
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_6">
            <span class="md-nav__icon md-icon"></span>
            Util
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../util/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    util
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../util/tmp/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    tmp
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_6" >
        
          
          <label class="md-nav__link" for="__nav_6" id="__nav_6_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Reference
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_6">
            <span class="md-nav__icon md-icon"></span>
            Reference
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../help/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_7" >
        
          
          <label class="md-nav__link" for="__nav_7" id="__nav_7_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Resources
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_7_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_7">
            <span class="md-nav__icon md-icon"></span>
            Resources
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/faq/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    FAQ
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/troubleshooting/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Troubleshooting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/changelog/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Changelog
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/wild/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    In The Wild
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/refs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    References
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  

  
  


<h1 id="tun">Tun<a class="headerlink" href="#tun" title="Permanent link">&para;</a></h1>
<div class="toc">
<ul>
<li><a href="#tun">Tun</a><ul>
<li><a href="#intro">Intro</a></li>
<li><a href="#how-it-works">How it Works</a></li>
<li><a href="#listen-tun">Listen Tun</a><ul>
<li><a href="#example">Example</a></li>
<li><a href="#redirect-example">Redirect Example</a><ul>
<li><a href="#binding-to-udp-53">Binding to UDP 53</a><ul>
<li><a href="#create-the-tun">Create the Tun</a></li>
<li><a href="#start-merlin">Start Merlin</a></li>
<li><a href="#start-listener">Start Listener</a></li>
<li><a href="#create-the-redirect">Create the Redirect</a></li>
<li><a href="#deploy-payload">Deploy Payload</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li><a href="#connect-tun">Connect Tun</a><ul>
<li><a href="#example_1">Example</a></li>
</ul>
</li>
<li><a href="#auto-roll">Auto-Roll</a><ul>
<li><a href="#example_2">Example</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<h2 id="intro">Intro<a class="headerlink" href="#intro" title="Permanent link">&para;</a></h2>
<p>You probably know that <code>autovnet</code> supports magic <a href="../proxy/">proxying</a> and magic <a href="../listen/">listening</a>.
Those techniques are lightweight and flexible, and if you can, you should prefer to use them.</p>
<p>But the <code>proxy</code> and <code>listen</code> primitives only support <code>TCP</code> traffic.
What if you need to send <code>UDP</code>, <code>ICMP</code>, or even raw <code>IP</code> packets?</p>
<p>Use a <code>tun</code>!</p>
<p><code>autovnet</code>'s <code>tun</code> primitive is extremely powerful, supporting any <code>IP</code>-based protocol (i.e. arbitrary <code>L3</code> traffic) through the use of a <a href="https://en.wikipedia.org/wiki/TUN/TAP">Unix TUN</a>.</p>
<h2 id="how-it-works">How it Works<a class="headerlink" href="#how-it-works" title="Permanent link">&para;</a></h2>
<p><a href="../../../rtfm/autovnet/">The techinical details are here.</a>. This is the quick version.</p>
<p>When you connect to a VPN, you get a <code>TUN</code> interface locally, and it can handle any <code>IP</code> traffic, and everything Just Works (TM).</p>
<p><code>autovnet</code>'s <code>tun</code> feature creates a VPN-like <code>TUN</code> interface that magically obfuscates your packets.</p>
<p>So when you bring up a <code>tun</code>, you get a random IP address that is mapped 1:1 to your local <code>TUN</code> address (the <code>IP</code> address of your <code>TUN</code> interface, as shown by the <code>ip a</code> command).</p>
<h2 id="listen-tun">Listen Tun<a class="headerlink" href="#listen-tun" title="Permanent link">&para;</a></h2>
<p>A listen <code>tun</code> can only accept callbacks (the target must initiate the connection to you).
You can have as many listen <code>tun</code>s at the same time as you want!!</p>
<h3 id="example">Example<a class="headerlink" href="#example" title="Permanent link">&para;</a></h3>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Waiting<span class="w"> </span><span class="k">for</span><span class="w"> </span>IPAM<span class="w"> </span>...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>IPAM<span class="w"> </span>is<span class="w"> </span>ready!

<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up<span class="w"> </span>foamy_benefit
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>tun_ip:<span class="w"> </span><span class="m">169</span>.254.0.4

<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Starting<span class="w"> </span>nebula...
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Waiting<span class="w"> </span><span class="k">for</span><span class="w"> </span>rtfm-216a4d5f51<span class="w"> </span>/<span class="w"> </span>rtfm-foamy-benefit<span class="w"> </span>...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>tun<span class="w"> </span>is<span class="w"> </span>ready!

<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>map_ip:<span class="w"> </span><span class="m">10</span>.242.91.92
<span class="o">[</span>&gt;<span class="o">]</span><span class="w"> </span>Roll<span class="w"> </span>new<span class="w"> </span>IP?
<span class="w"> </span><span class="o">[</span>y/N<span class="o">]</span>:
</code></pre></div>
<p>Let's break down this output.</p>
<p>The first <code>tun</code> will take a while, so there are some status messages to keep you in the loop.</p>
<p><code>tun_ip</code> (here, <code>169.254.0.4</code>) is the <code>IP</code> address assigned to your local <code>TUN</code> interface.
This is the <em>local</em> end of you <code>tun</code>. A target cannot connect to the <em>local</em> end of your tun.</p>
<p>You might be thinking:</p>
<blockquote>
<p><em>Huh?</em> <code>169.254.0.0/16</code> are <a href="https://en.wikipedia.org/wiki/Link-local_address">Link-Local Addresses</a></p>
</blockquote>
<p>This is intentional, to help avoid confusion. These addresses are visually distinct and not routable, so it helps make it obvious that we are trusting <code>autovnet</code> to magic our packets into being valid :)</p>
<blockquote>
<p><a href="https://en.wikipedia.org/wiki/Link-local_address">Link-local addresses</a> may be assigned manually by an administrator ...</p>
<p>Look at me. I am the <em>administrator</em> now
  - <code>autovnet</code></p>
</blockquote>
<p>If you are starting the C2 server, you can bind to your <code>tun_ip</code> (or <code>0.0.0.0</code>).</p>
<p><code>autovnet rtfm tun up foamy_benefit</code> is the command you could run to re-create this <code>TUN</code> (with local <code>IP</code> <code>169.254.0.4</code>) in the future.</p>
<ul>
<li>Warning: make sure you do not have a conflicting <code>tun</code> running before you start a new <code>up</code>. This isn't validated, and will probably break both <code>tun</code>'s (just stop both and re-run the <code>tun up</code>)</li>
</ul>
<p><code>rtfm-216a4d5f51 / rtfm-foamy-benefit</code> is the interface name / interface alias as shown by <code>ip a</code> / <code>ip link show</code>.
You may be able to use these interface names in your favorite tools (e.g. <code>metasploit</code>).</p>
<p><code>map_ip</code> (here, <code>10.242.91.92</code>) is the <em>public</em> end of your <code>tun</code>. This is the <code>IP</code> that a target would connect to.</p>
<ul>
<li>Due to side-effects of magic, you (the player who ran <code>tun up</code>) can't actually connect to this <code>IP</code>. But other players and targets can.</li>
</ul>
<p><code>Roll new IP?</code> - That's right, you can instantly change the <em>public</em> end of your <code>tun</code>, and can change it freely, as many times as you want, without ever disconnecting! (Just enter <code>y</code>)</p>
<p>The <em>local</em> end of your <code>tun</code> (your <code>tun_ip</code>) does not change. So you don't need to restart any services if you roll your <code>map_ip</code>.</p>
<p>When you roll an <code>IP</code> any active connections (e.g. active <code>TCP</code> sessions) connected to the old <code>IP</code> are preserved, but new connections will fail.</p>
<p>E.g. if you caught a <code>TCP</code> reverse shell, you can roll your IP without breaking it. But if you have a beaconing RAT, the next beacon will fail if you roll your <code>IP</code>.</p>
<p>Want more <code>IP</code>s ?! </p>
<blockquote>
<p><em><em>slaps roof of <code>autovnet</code></em></em>
This bad boy can fit so many addresses in it</p>
</blockquote>
<p>You can have as many listen <code>tun</code>s as you want, e.g.</p>
<ul>
<li>Separately rollable <code>IP</code>s for different C2 servers</li>
<li>Exposing the same C2 server via separate <code>IP</code>s - each accessed only by a single target</li>
</ul>
<div class="highlight"><pre><span></span><code>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up<span class="w"> </span>--new
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Waiting<span class="w"> </span><span class="k">for</span><span class="w"> </span>IPAM<span class="w"> </span>...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>IPAM<span class="w"> </span>is<span class="w"> </span>ready!

<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up<span class="w"> </span>axiomatic_head
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>tun_ip:<span class="w"> </span><span class="m">169</span>.254.0.5

<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Starting<span class="w"> </span>nebula...
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Waiting<span class="w"> </span><span class="k">for</span><span class="w"> </span>rtfm-9fcf54ce5c<span class="w"> </span>/<span class="w"> </span>rtfm-axiomatic-head<span class="w"> </span>...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>tun<span class="w"> </span>is<span class="w"> </span>ready!

<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>map_ip:<span class="w"> </span><span class="m">10</span>.196.119.98
<span class="o">[</span>&gt;<span class="o">]</span><span class="w"> </span>Roll<span class="w"> </span>new<span class="w"> </span>IP?
<span class="w"> </span><span class="o">[</span>y/N<span class="o">]</span>:
</code></pre></div>
<p>Now that we have some <code>map_ip</code>s, let's start a new service and prove that target's can access it over both <code>map_ip</code>s, with no additional configuration.</p>
<p>(All ports on <code>tun_ip</code> are immediately exposed, so you can bind to any port you want).</p>
<p>Player:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>python<span class="w"> </span>-m<span class="w"> </span>http.server
Serving<span class="w"> </span>HTTP<span class="w"> </span>on<span class="w"> </span><span class="m">0</span>.0.0.0<span class="w"> </span>port<span class="w"> </span><span class="m">8000</span><span class="w"> </span><span class="o">(</span>http://0.0.0.0:8000/<span class="o">)</span><span class="w"> </span>...
</code></pre></div></p>
<p>Target:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>curl<span class="w"> </span><span class="m">10</span>.242.91.92:8000
&lt;!DOCTYPE<span class="w"> </span>HTML<span class="w"> </span>PUBLIC<span class="w"> </span><span class="s2">&quot;-//W3C//DTD HTML 4.01//EN&quot;</span><span class="w"> </span><span class="s2">&quot;http://www.w3.org/TR/html4/strict.dtd&quot;</span>&gt;
&lt;html&gt;
...
&lt;/html&gt;

$<span class="w"> </span>curl<span class="w"> </span><span class="m">10</span>.196.119.98:8000
&lt;!DOCTYPE<span class="w"> </span>HTML<span class="w"> </span>PUBLIC<span class="w"> </span><span class="s2">&quot;-//W3C//DTD HTML 4.01//EN&quot;</span><span class="w"> </span><span class="s2">&quot;http://www.w3.org/TR/html4/strict.dtd&quot;</span>&gt;
&lt;html&gt;
...
&lt;/html&gt;
</code></pre></div></p>
<p>Player gets both connections:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>python<span class="w"> </span>-m<span class="w"> </span>http.server
Serving<span class="w"> </span>HTTP<span class="w"> </span>on<span class="w"> </span><span class="m">0</span>.0.0.0<span class="w"> </span>port<span class="w"> </span><span class="m">8000</span><span class="w"> </span><span class="o">(</span>http://0.0.0.0:8000/<span class="o">)</span><span class="w"> </span>...
<span class="m">192</span>.168.49.1<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">30</span>/Mar/2022<span class="w"> </span><span class="m">20</span>:13:08<span class="o">]</span><span class="w"> </span><span class="s2">&quot;GET / HTTP/1.1&quot;</span><span class="w"> </span><span class="m">200</span><span class="w"> </span>-
<span class="m">192</span>.168.49.1<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">30</span>/Mar/2022<span class="w"> </span><span class="m">20</span>:13:28<span class="o">]</span><span class="w"> </span><span class="s2">&quot;GET / HTTP/1.1&quot;</span><span class="w"> </span><span class="m">200</span><span class="w"> </span>-
</code></pre></div></p>
<p>In this case, <code>192.168.49.1</code> is the true <code>IP</code> of the target.
Connections to the <code>tun</code> listener exposes the "public" <code>IP</code> of the target, which might be the "true" <code>IP</code> (that the target would see in their own <code>ip a</code> / <code>ipconfig</code> output).
But if the target is behind a NAT, then the connections would be "from" the NAT address.</p>
<p>Remember, any tool that needs unique peer addresses / connections to come directly from a target are bad tools, because they not compatible with redirection.
But if you absolutely must use a tool like that, then <code>tun</code> listeners may give you more accurate peer addresses than <a href="../listen/">callbacks proxied through <code>listen</code></a> (which all show up as from <code>localhost</code>).</p>
<h3 id="redirect-example">Redirect Example<a class="headerlink" href="#redirect-example" title="Permanent link">&para;</a></h3>
<p>The <code>autovnet rtfm tun redirect</code> command provides additional flexibility in how you use your <code>tun</code> IP.</p>
<p>Let's consider the following (relatively common) scenario:
You want to use a DNS-based payload / want your traffic to appear on the wire as <code>UDP 53</code>.</p>
<p><code>tun</code> allows you to receive UDP traffic, but unfortunately, <code>UDP 53</code> is probably already bound on your system by <code>systemd-resolve</code> or similar (it's part of how your system handles its own DNS).</p>
<p>The <code>redirect</code> command fixes this by allowing you to</p>
<ol>
<li>Start a listener on a port you can actually bind to</li>
<li>Configure your payload with the port you want the target to see</li>
<li>Make sure the packets your payload sends reach your listener</li>
</ol>
<h4 id="binding-to-udp-53">Binding to UDP 53<a class="headerlink" href="#binding-to-udp-53" title="Permanent link">&para;</a></h4>
<p>Here is a quick example with <code>merlin</code> (see <a href="../../pwn/merlin/">merlin usage</a> for more details):</p>
<h5 id="create-the-tun">Create the Tun<a class="headerlink" href="#create-the-tun" title="Permanent link">&para;</a></h5>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up<span class="w"> </span>
...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up<span class="w"> </span>tiny_training
...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>map_ip:<span class="w"> </span><span class="m">254</span>.63.187.123
</code></pre></div>
<h5 id="start-merlin">Start Merlin<a class="headerlink" href="#start-merlin" title="Permanent link">&para;</a></h5>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>server
...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>wretched_concept
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>listen:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>listener<span class="w"> </span>wretched_concept
...
Merlin»
</code></pre></div>
<h5 id="start-listener">Start Listener<a class="headerlink" href="#start-listener" title="Permanent link">&para;</a></h5>
<p>Note that we cannot actually bind to UDP <code>:53</code>, but we want our packets to be UDP <code>:53</code>.</p>
<div class="highlight"><pre><span></span><code>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>listener<span class="w"> </span>wretched_concept<span class="w"> </span>-P<span class="w"> </span>http3<span class="w"> </span>-p<span class="w"> </span><span class="m">53</span><span class="w"> </span>--dest-port<span class="w"> </span><span class="m">5553</span>
</code></pre></div>
<p>That command starts a <code>merlin</code> listener on UDP <code>:5553</code>, which we can confirm in the <code>merlin</code> shell:</p>
<div class="highlight"><pre><span></span><code>Merlin»<span class="w"> </span>listeners<span class="w"> </span>
Merlin<span class="o">[</span>listeners<span class="o">]</span>»<span class="w"> </span>list

+-----------------+-----------+------+----------+---------+--------------------------------+
<span class="p">|</span><span class="w">      </span>NAME<span class="w">       </span><span class="p">|</span><span class="w"> </span>INTERFACE<span class="w"> </span><span class="p">|</span><span class="w"> </span>PORT<span class="w"> </span><span class="p">|</span><span class="w"> </span>PROTOCOL<span class="w"> </span><span class="p">|</span><span class="w"> </span>STATUS<span class="w">  </span><span class="p">|</span><span class="w">          </span>DESCRIPTION<span class="w">           </span><span class="p">|</span>
+-----------------+-----------+------+----------+---------+--------------------------------+
<span class="p">|</span><span class="w"> </span>charming_island<span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="m">0</span>.0.0.0<span class="w">  </span><span class="p">|</span><span class="w"> </span><span class="m">5553</span><span class="w"> </span><span class="p">|</span><span class="w">  </span>HTTP3<span class="w">   </span><span class="p">|</span><span class="w"> </span>Running<span class="w"> </span><span class="p">|</span><span class="w">    </span>agent<span class="w"> </span>-proto<span class="w"> </span>http3<span class="w"> </span>-url<span class="w">     </span><span class="p">|</span>
<span class="p">|</span><span class="w">                 </span><span class="p">|</span><span class="w">           </span><span class="p">|</span><span class="w">      </span><span class="p">|</span><span class="w">          </span><span class="p">|</span><span class="w">         </span><span class="p">|</span><span class="w">       </span>https://MAP_IP:53<span class="w">        </span><span class="p">|</span>
+-----------------+-----------+------+----------+---------+--------------------------------+
</code></pre></div>
<h5 id="create-the-redirect">Create the Redirect<a class="headerlink" href="#create-the-redirect" title="Permanent link">&para;</a></h5>
<p>Here, we use codename from the previous <code>tun</code> command.</p>
<p>We match UDP packets that come in via our <code>tiny_training</code> <code>tun</code> with a destination port <code>53.
We then</code>redirect<code>those packets (modify the destination port) to be</code>5553`.</p>
<p>In other words, we <code>-m</code>atch the packets our payloadd will send, and redirect them <code>-t</code>o our listener, on port <code>:5553</code></p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>redirect<span class="w"> </span>-P<span class="w"> </span>udp<span class="w"> </span>-m<span class="w"> </span><span class="m">53</span><span class="w"> </span>-t<span class="w"> </span><span class="m">5553</span><span class="w"> </span>tiny_training
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>:53<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span>:5553
</code></pre></div>
<p>The redirect is active until we <code>CTRL+C</code>, which will delete it for us.</p>
<h5 id="deploy-payload">Deploy Payload<a class="headerlink" href="#deploy-payload" title="Permanent link">&para;</a></h5>
<p><strong>Note: payload must run on a different system because of routing weirdness</strong></p>
<p>Here, we use <code>254.63.187.123</code> (the <code>map_ip</code> reported by our <code>tun</code>) and <code>:53</code>, which is the left side of our <code>redirect</code>
<div class="highlight"><pre><span></span><code>./agent<span class="w"> </span>-proto<span class="w"> </span>http3<span class="w"> </span>-url<span class="w"> </span>https://254.63.187.123:53<span class="w"> </span>-sleep<span class="w"> </span>10s<span class="w"> </span>-skew<span class="w"> </span><span class="m">15</span>
</code></pre></div></p>
<p>Our merlin server gets a successful checkin, indicating that our packets reached the <code>http3</code> listener, running on <code>:5553 (UDP)</code>.</p>
<h2 id="connect-tun">Connect Tun<a class="headerlink" href="#connect-tun" title="Permanent link">&para;</a></h2>
<p>A <em>connect</em> <code>tun</code> is very similar to a <em>listen</em> <code>tun</code>, but it allows you to change the source <code>IP</code> that targets will see when you connect.</p>
<p>Remember, <code>autovnet</code>'s <code>.proxy</code> feature is awesome, but can only deliver <code>TCP</code> traffic, and is not compatibile with all tools.
A <em>connect</em> <code>tun</code> allows delivering arbitrary <code>IP</code> traffic, and is tool agnostic.</p>
<p>(Don't worry, you can still use <code>.proxy</code> while you have a <code>tun</code> up - the <code>.proxy</code> will ignore local routes, bypassing the <code>tun</code>)</p>
<p>This works by specifying one or more IP addresses (or CIDR networks) that should be routed through the <code>tun</code>.
Because of this, any existing connections to the target network(s) will break when you bring the <code>tun</code> up or down,
but you can freely roll your <code>IP</code> while it's up without breaking anything.</p>
<h3 id="example_1">Example<a class="headerlink" href="#example_1" title="Permanent link">&para;</a></h3>
<p>Assuming a target network of <code>192.168.49.0/24</code>, the player can easily create a connect <code>tun</code>:</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up<span class="w"> </span>-r<span class="w"> </span><span class="m">192</span>.168.49.0/24<span class="w">                                             </span>
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Waiting<span class="w"> </span><span class="k">for</span><span class="w"> </span>IPAM<span class="w"> </span>...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>IPAM<span class="w"> </span>is<span class="w"> </span>ready!

<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up<span class="w"> </span>ten_dot
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>tun_ip:<span class="w"> </span><span class="m">169</span>.254.0.2

<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Starting<span class="w"> </span>nebula...
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Waiting<span class="w"> </span><span class="k">for</span><span class="w"> </span>rtfm-a676147be3<span class="w"> </span>/<span class="w"> </span>rtfm-ten-dot<span class="w"> </span>...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>tun<span class="w"> </span>is<span class="w"> </span>ready!

<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>map_ip:<span class="w"> </span><span class="m">10</span>.204.73.46
<span class="o">[</span>&gt;<span class="o">]</span><span class="w"> </span>Roll<span class="w"> </span>new<span class="w"> </span>IP?
<span class="w"> </span><span class="o">[</span>y/N<span class="o">]</span>:
</code></pre></div>
<p>Now, all new <code>IP</code> connections to <code>192.168.49.0/24</code> are routed through the <code>tun</code> and mapped to <code>10.204.73.46</code> by the <code>autovnet server</code>.</p>
<p>We can demonstrate this by connecting to a target while the <code>tun</code> is up:
<div class="highlight"><pre><span></span><code><span class="c1"># Player</span>
$<span class="w"> </span>.ssh<span class="w"> </span><span class="m">192</span>.168.49.1

<span class="c1"># Target</span>
$<span class="w"> </span><span class="nb">echo</span><span class="w"> </span><span class="nv">$SSH_CLIENT</span>
<span class="m">10</span>.204.73.46<span class="w"> </span><span class="m">59106</span><span class="w"> </span><span class="m">22</span>

$<span class="w"> </span>sudo<span class="w"> </span>ss<span class="w"> </span>-untap<span class="w"> </span><span class="p">|</span><span class="w"> </span>grep<span class="w"> </span><span class="m">10</span>.204.73.46
tcp<span class="w">   </span>ESTAB<span class="w">  </span><span class="m">0</span><span class="w">      </span><span class="m">0</span><span class="w">           </span><span class="m">192</span>.168.49.1:22<span class="w">   </span><span class="m">10</span>.204.73.46:59106<span class="w"> </span>users:<span class="o">((</span><span class="s2">&quot;sshd&quot;</span>,pid<span class="o">=</span><span class="m">1446</span>,fd<span class="o">=</span><span class="m">4</span><span class="o">)</span>,<span class="o">(</span><span class="s2">&quot;sshd&quot;</span>,pid<span class="o">=</span><span class="m">1439</span>,fd<span class="o">=</span><span class="m">4</span><span class="o">))</span>
</code></pre></div></p>
<p>From the target's perspective, the <code>ssh</code> connection came from the <code>map_ip</code>, <code>10.204.73.46</code>.</p>
<p>To further demonstrate the power of <code>tun</code>, let's leave the <code>ssh</code> session open and roll a new <code>IP</code> (by entering <code>y</code> at the prompt).</p>
<div class="highlight"><pre><span></span><code>...
<span class="o">[</span>&gt;<span class="o">]</span><span class="w"> </span>Roll<span class="w"> </span>new<span class="w"> </span>IP?
<span class="w"> </span><span class="o">[</span>y/N<span class="o">]</span>:<span class="w"> </span>y
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>map_ip:<span class="w"> </span><span class="m">10</span>.202.45.202
<span class="o">[</span>&gt;<span class="o">]</span><span class="w"> </span>Roll<span class="w"> </span>new<span class="w"> </span>IP?
<span class="w"> </span><span class="o">[</span>y/N<span class="o">]</span>:
</code></pre></div>
<p>The previously created <code>ssh</code> session is unaffected (and from the target's perspective, is still from <code>10.204.73.46</code>.</p>
<p>But now, new connections will use <code>10.202.45.202</code> as the source IP.</p>
<p>To demonstrate that any <code>IP</code> traffic can be delivered, we'll start a <code>UDP</code> service on target:</p>
<div class="highlight"><pre><span></span><code><span class="c1"># Target</span>
$<span class="w"> </span>nc<span class="w"> </span>-nvlup<span class="w"> </span><span class="m">5353</span>
</code></pre></div>
<p>Now, from the player machine, we'll send some <code>ICMP</code> traffic (with <code>ping</code>) and <code>UDP</code> traffic (with <code>nc</code>)</p>
<div class="highlight"><pre><span></span><code><span class="c1"># The ping is successful</span>
$<span class="w"> </span>ping<span class="w"> </span>-c<span class="w"> </span><span class="m">1</span><span class="w"> </span><span class="m">192</span>.168.49.1
PING<span class="w"> </span><span class="m">192</span>.168.49.1<span class="w"> </span><span class="o">(</span><span class="m">192</span>.168.49.1<span class="o">)</span><span class="w"> </span><span class="m">56</span><span class="o">(</span><span class="m">84</span><span class="o">)</span><span class="w"> </span>bytes<span class="w"> </span>of<span class="w"> </span>data.
<span class="m">64</span><span class="w"> </span>bytes<span class="w"> </span>from<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span><span class="nv">icmp_seq</span><span class="o">=</span><span class="m">1</span><span class="w"> </span><span class="nv">ttl</span><span class="o">=</span><span class="m">62</span><span class="w"> </span><span class="nv">time</span><span class="o">=</span><span class="m">1</span>.16<span class="w"> </span>ms

---<span class="w"> </span><span class="m">192</span>.168.49.1<span class="w"> </span>ping<span class="w"> </span>statistics<span class="w"> </span>---
<span class="m">1</span><span class="w"> </span>packets<span class="w"> </span>transmitted,<span class="w"> </span><span class="m">1</span><span class="w"> </span>received,<span class="w"> </span><span class="m">0</span>%<span class="w"> </span>packet<span class="w"> </span>loss,<span class="w"> </span><span class="nb">time</span><span class="w"> </span>0ms
rtt<span class="w"> </span>min/avg/max/mdev<span class="w"> </span><span class="o">=</span><span class="w"> </span><span class="m">1</span>.160/1.160/1.160/0.000<span class="w"> </span>ms
</code></pre></div>
<div class="highlight"><pre><span></span><code><span class="c1"># The UDP connection is successful</span>
$<span class="w"> </span>nc<span class="w"> </span>-nvz<span class="w"> </span>-u<span class="w"> </span><span class="m">192</span>.168.49.1<span class="w"> </span><span class="m">5353</span>
Connection<span class="w"> </span>to<span class="w"> </span><span class="m">192</span>.168.49.1<span class="w"> </span><span class="m">5353</span><span class="w"> </span>port<span class="w"> </span><span class="o">[</span>udp/*<span class="o">]</span><span class="w"> </span>succeeded!
</code></pre></div>
<p>Again, from the target's perspective, all connections come from the current <code>map_ip</code> (<code>10.202.45.202</code>).
<div class="highlight"><pre><span></span><code><span class="c1"># Target</span>
$<span class="w"> </span>nc<span class="w"> </span>-nvlup<span class="w"> </span><span class="m">5353</span>
Ncat:<span class="w"> </span>Version<span class="w"> </span><span class="m">7</span>.92<span class="w"> </span><span class="o">(</span><span class="w"> </span>https://nmap.org/ncat<span class="w"> </span><span class="o">)</span>
Ncat:<span class="w"> </span>Listening<span class="w"> </span>on<span class="w"> </span>:::5353
Ncat:<span class="w"> </span>Listening<span class="w"> </span>on<span class="w"> </span><span class="m">0</span>.0.0.0:5353
Ncat:<span class="w"> </span>Connection<span class="w"> </span>from<span class="w"> </span><span class="m">10</span>.202.45.202.
XXXXX
</code></pre></div></p>
<p>If so inclined, you can do a packet capture on target to further demonstrate that only the <code>map_ip</code> (<code>10.202.45.202</code>) is visibile to the target.
<div class="highlight"><pre><span></span><code><span class="c1"># Target</span>
$<span class="w"> </span>sudo<span class="w"> </span>tcpdump<span class="w"> </span>-vvn<span class="w"> </span>-i<span class="w"> </span>eth0<span class="w"> </span>icmp
tcpdump:<span class="w"> </span>listening<span class="w"> </span>on<span class="w"> </span>eth0,<span class="w"> </span>link-type<span class="w"> </span>EN10MB<span class="w"> </span><span class="o">(</span>Ethernet<span class="o">)</span>,<span class="w"> </span>snapshot<span class="w"> </span>length<span class="w"> </span><span class="m">262144</span><span class="w"> </span>bytes

<span class="c1"># This is the PING</span>
<span class="m">17</span>:06:28.153097<span class="w"> </span>IP<span class="w"> </span><span class="o">(</span>tos<span class="w"> </span>0x0,<span class="w"> </span>ttl<span class="w"> </span><span class="m">63</span>,<span class="w"> </span>id<span class="w"> </span><span class="m">48669</span>,<span class="w"> </span>offset<span class="w"> </span><span class="m">0</span>,<span class="w"> </span>flags<span class="w"> </span><span class="o">[</span>DF<span class="o">]</span>,<span class="w"> </span>proto<span class="w"> </span>ICMP<span class="w"> </span><span class="o">(</span><span class="m">1</span><span class="o">)</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">84</span><span class="o">)</span>
<span class="w">    </span><span class="m">10</span>.202.45.202<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">8</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>

<span class="c1"># This is the PING reply</span>
<span class="m">17</span>:06:28.153158<span class="w"> </span>IP<span class="w"> </span><span class="o">(</span>tos<span class="w"> </span>0x0,<span class="w"> </span>ttl<span class="w"> </span><span class="m">64</span>,<span class="w"> </span>id<span class="w"> </span><span class="m">64134</span>,<span class="w"> </span>offset<span class="w"> </span><span class="m">0</span>,<span class="w"> </span>flags<span class="w"> </span><span class="o">[</span>none<span class="o">]</span>,<span class="w"> </span>proto<span class="w"> </span>ICMP<span class="w"> </span><span class="o">(</span><span class="m">1</span><span class="o">)</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">84</span><span class="o">)</span>
<span class="w">    </span><span class="m">192</span>.168.49.1<span class="w"> </span>&gt;<span class="w"> </span><span class="m">10</span>.202.45.202:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>reply,<span class="w"> </span>id<span class="w"> </span><span class="m">8</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
</code></pre></div></p>
<h2 id="auto-roll">Auto-Roll<a class="headerlink" href="#auto-roll" title="Permanent link">&para;</a></h2>
<p>Changing your <code>tun</code>'s <code>map_ip</code> is easy: just enter <code>y</code> at the prompt.</p>
<p>But you can also roll your <code>map_ip</code> at a fixed interval, with the <code>-i</code> option.
This generally makes the most sense when used with <code>-r</code> for a <em>connect</em> <code>tun</code>.</p>
<p>By running a command like:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up<span class="w"> </span>-r<span class="w"> </span><span class="m">192</span>.168.49.0/24<span class="w"> </span>-i<span class="w"> </span><span class="m">60</span>
</code></pre></div>
... at the start of an event, your "public" (target-facing) <code>IP</code> will automatically change every 60 seconds!</p>
<p>You should always <code>.proxy</code> when you can, and you can always enter <code>y</code> to roll a new <code>IP</code> immediately,
but with all Red Teamers running a rolling <em>connect</em> <code>tun</code> in the background, Blue Team will experience massive <code>IP</code> variety in their logs / PCAPs.</p>
<p>This also severely disincentivizes blocking <code>IP</code> addresses, since it's trivially easy for Red Team to map a new <code>IP</code>,
and any candidate <code>IP</code> for blocking could very likely already be rotated by the time it is blocked.</p>
<h3 id="example_2">Example<a class="headerlink" href="#example_2" title="Permanent link">&para;</a></h3>
<p>Here is an example of sending a <code>ping</code> every minute:
<div class="highlight"><pre><span></span><code><span class="c1"># Player</span>
$<span class="w"> </span><span class="k">while</span><span class="w"> </span>:<span class="p">;</span><span class="w"> </span><span class="k">do</span><span class="w"> </span>ping<span class="w"> </span>-c<span class="w"> </span><span class="m">1</span><span class="w"> </span><span class="m">192</span>.168.49.1<span class="p">;</span><span class="w"> </span>sleep<span class="w"> </span><span class="m">60</span><span class="p">;</span><span class="w"> </span><span class="k">done</span>

<span class="c1"># Target (tcpdump)</span>
...
<span class="m">10</span>.196.69.193<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">16</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.202.22.138<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">17</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.254.232.65<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">18</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.235.185.119<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">19</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.192.10.97<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">20</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.251.224.41<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">21</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.200.244.162<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">22</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.214.237.140<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">23</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.244.74.141<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">24</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.207.80.133<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">25</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.217.91.96<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">27</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.210.55.137<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">28</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.195.68.76<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">29</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.234.83.239<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">30</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
<span class="m">10</span>.231.158.109<span class="w"> </span>&gt;<span class="w"> </span><span class="m">192</span>.168.49.1:<span class="w"> </span>ICMP<span class="w"> </span><span class="nb">echo</span><span class="w"> </span>request,<span class="w"> </span>id<span class="w"> </span><span class="m">31</span>,<span class="w"> </span>seq<span class="w"> </span><span class="m">1</span>,<span class="w"> </span>length<span class="w"> </span><span class="m">64</span>
</code></pre></div></p>
<p>Each packet has a unique source <code>IP</code>, due to the periodic <code>IP</code> rotation.</p>





                
              </article>
            </div>
          
          
        </div>
        
          <button type="button" class="md-top md-icon" data-md-component="top" hidden>
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M13 20h-2V8l-5.5 5.5-1.42-1.42L12 4.16l7.92 7.92-1.42 1.42L13 8v12Z"/></svg>
  Back to top
</button>
        
      </main>
      
        <footer class="md-footer">
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-copyright">
  
  
    Made with
    <a href="https://squidfunk.github.io/mkdocs-material/" target="_blank" rel="noopener">
      Material for MkDocs
    </a>
  
</div>
      
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    
    <script id="__config" type="application/json">{"base": "../../..", "features": ["search.suggest", "search.highlight", "navigation.instant", "navigation.tracking", "navigation.tabs", "navigation.tabs.sticky", "navigation.top", "navigation.expand", "toc.integrate", "toc.follow", "navigation.top", "content.code.copy"], "search": "../../../assets/javascripts/workers/search.f886a092.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version": "Select version"}}</script>
    
    
      <script src="../../../assets/javascripts/bundle.aecac24b.min.js"></script>
      
    
  </body>
</html>